#include "Movable.h"
#include "Sprite.h"
#include "Vram.h"
#include "VVram.h"
#include "Chars.h"

constexpr byte InvalidPattern = 0xff;
constexpr byte MaxY = VVramHeight - 2;

Sprite[SpriteCount] Sprites;

void InitSprites()
{
    HideAllSprites();
}

void HideAllSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        p->pattern = InvalidPattern;
        p->oldPattern = InvalidPattern;
    }
}


void ShowSprite(ptr<Movable> pMovable, byte pattern)
{
    ptr<Sprite> p;
    p = Sprites + pMovable->sprite;
    p->x = pMovable->x;
    p->y = pMovable->y;
    p->pattern = pattern;
}


void HideSprite(byte index) 
{
    ptr<Sprite> p;
    p = Sprites + index;
    p->pattern = InvalidPattern;
}


void EraseSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        if (p->oldPattern != InvalidPattern) {
            byte x, y, size;
            x = p->oldX;
            y = p->oldY;
            if (p->oldPattern >= Pattern_MyBullet) {
                size = 1;
                x >>= 1;
                y >>= 1;
            }
            else {
                size = 2;
            }
            if (y <= MaxY && x < VVramWidth) {
                EraseBackup(x, y, size);
            }
        }
    }
}


void DrawSprites()
{
    ptr<Sprite> p;
    p = Sprites + SpriteCount - 1;
    repeat (SpriteCount) {
        if (p->pattern != InvalidPattern) {
            byte x, y, size;
            x = p->x;
            y = p->y;
            if (p->pattern >= Pattern_MyBullet) {
                size = 1;
                x >>= 1;
                y >>= 1;
            }
            else {
                size = 2;
            }
            if (y <= MaxY && x < VVramWidth) {
                DrawSprite(x, y, p->pattern, size);
            }
        }
        p->oldX = p->x;
        p->oldY = p->y;
        p->oldPattern = p->pattern;
        --p;
    }
}
