#include "Vram.h"
#include "Chars.h"
#include "Movable.h"
#include "Sprite.h"
#include "VVram.h"
#include "Fort.h"

extern byte[] MonoPatternSource, FortPatternSource, ColorPatternSource, SpritePatternSource;
constexpr byte SourceCharSize = 8 * 3;

byte[24 * Char_End] CharPattern;
// byte[256 * PatternCount] SpritePattern;

void InitVram()
{
    ClearScreen();
    MakePatternMono(Char_Ascii, MonoPatternSource + Char_Ascii * CharHeight, 64, 0x07);
    MakePatternMono(Char_Logo, MonoPatternSource + Char_Logo * CharHeight, 16 + 3, 0x06);
    MakePatternColor(Char_Remain, ColorPatternSource, 4);
    MakePatternColor(Char_Fort, FortPatternSource, 7 * 4);
}


void DrawAll()
{
    EraseSprites();
    GroundToVVram();
    DrawForts();
    VVramToVram();
    DrawSprites();
    SwapVram();
    // CallSound();
}


word PrintC(word vram, byte c)
{
    return Put(vram, c - ' ');
}


void Put2C(word vram, byte c)
{
    repeat (2) {
        repeat (2) {
            vram = Put(vram, c);
            ++c;
        }
        vram += VramRowSize - 2 * VramStep;
    }
}
